.package_base: &package_base
  image: docker:stable
  stage: build
  services:
    - name: "docker:19.03.5-dind"
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  tags:
    - docker

Build Frontend 🛠:
  stage: build
  image: node:14-buster
  before_script:
    - cd frontend
    - rm -rf node_modules/
    - npm cache clean --force
  script:
    - npm install
  #  artifacts:
  #    paths:
  #      - frontend/node_modules/
  rules:
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME'  # Run on merge requests when the frontend has changed
      changes:
        - frontend/**/*
      when: always

Build Backend 🛠:
  stage: build
  image: node:14.16-alpine3.11
  before_script:
    - cd backend
  script:
    - npm i
  artifacts:
    paths:
      - backend/node_modules/
  rules:
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME'  # Run on merge requests when the backend changes
      changes:
        - backend/**/*
      when: always

Package Frontend 📦:
  <<: *package_base
  stage: package
  variables:
    API_URL: '$CI_COMMIT_REF_SLUG-api.$KUBE_INGRESS_BASE_DOMAIN'
  script:
    - echo $API_URL
    - DOCKER_BUILDKIT=1 docker build -t $CI_REGISTRY_IMAGE/frontend/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA ./frontend --build-arg NEXT_PUBLIC_API_URL=$CI_COMMIT_REF_SLUG.$APP_NAME-api.$KUBE_INGRESS_BASE_DOMAIN
    - docker tag $CI_REGISTRY_IMAGE/frontend/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA $CI_REGISTRY_IMAGE/frontend/$CI_COMMIT_REF_SLUG:latest
    - docker push $CI_REGISTRY_IMAGE/frontend/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA
    - docker push $CI_REGISTRY_IMAGE/frontend/$CI_COMMIT_REF_SLUG:latest
  rules:
    - if: '$PACKAGE_DISABLED'
      when: never
    - if: '$CI_COMMIT_REF_NAME == "master"'
      when: never      
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME'  # Run on merge requests when frontend has changed
      when: always
  tags:
    - docker
  needs:
    []

Package Backend 📦:
  <<: *package_base
  stage: package
  script:
    - DOCKER_BUILDKIT=1 docker build -t $CI_REGISTRY_IMAGE/backend/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA ./backend
    - docker tag $CI_REGISTRY_IMAGE/backend/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA $CI_REGISTRY_IMAGE/backend/$CI_COMMIT_REF_SLUG:latest
    - docker push $CI_REGISTRY_IMAGE/backend/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA
    - docker push $CI_REGISTRY_IMAGE/backend/$CI_COMMIT_REF_SLUG:latest
  rules:
    - if: '$PACKAGE_DISABLED'
      when: never
    - if: '$CI_COMMIT_REF_NAME == "master"'
      when: never            
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME'  # Checking for the presence of a variable is possible
      when: always
  tags:
    - docker
  needs:
    []

Package Latest 🏷: # build from master, tag as latest, tag releases will be pulled from this.
  <<: *package_base
  stage: release
  variables:
    KUBE_INGRESS_BASE_DOMAIN: staging.glaas.io
  script:
    - DOCKER_BUILDKIT=1 docker build -t $CI_REGISTRY_IMAGE/frontend/$CI_COMMIT_REF_SLUG:latest ./frontend --build-arg NEXT_PUBLIC_API_URL=$CI_COMMIT_REF_SLUG.$APP_NAME-api.$KUBE_INGRESS_BASE_DOMAIN
    - DOCKER_BUILDKIT=1 docker build -t $CI_REGISTRY_IMAGE/backend/$CI_COMMIT_REF_SLUG:latest ./backend
    - docker push $CI_REGISTRY_IMAGE/frontend/$CI_COMMIT_REF_SLUG:latest
    - docker push $CI_REGISTRY_IMAGE/backend/$CI_COMMIT_REF_SLUG:latest    
  rules:
    - if: '$CI_COMMIT_BRANCH == "staging"'
      when: always
  needs:
    []

Package Release: # build from master, tag as latest, tag releases will be pulled from this.
  <<: *package_base
  stage: release
  variables:
    KUBE_INGRESS_BASE_DOMAIN: prod.glaas.io
  script:
    - DOCKER_BUILDKIT=1 docker build -t $CI_REGISTRY_IMAGE/frontend/production:$CI_COMMIT_TAG ./frontend --build-arg NEXT_PUBLIC_API_URL=production.$APP_NAME-api.$KUBE_INGRESS_BASE_DOMAIN
    - DOCKER_BUILDKIT=1 docker build -t $CI_REGISTRY_IMAGE/backend/production:$CI_COMMIT_TAG ./backend
    - docker push $CI_REGISTRY_IMAGE/frontend/production:$CI_COMMIT_TAG
    - docker push $CI_REGISTRY_IMAGE/backend/production:$CI_COMMIT_TAG    
  rules:
    - if: '$CI_COMMIT_TAG'
      when: always       
  needs:
    []    

